diff --git a/content/renderer/media/gstreamer/webmediaplayer_gstreamer.h b/content/renderer/media/gstreamer/webmediaplayer_gstreamer.h
new file mode 100644
index 0000000..5c4d4bc
--- /dev/null
+++ b/content/renderer/media/gstreamer/webmediaplayer_gstreamer.h
@@ -0,0 +1,390 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef MEDIA_GSTREAMER_WEBMEDIAPLAYER_GSTREAMER_H_
+#define MEDIA_GSTREAMER_WEBMEDIAPLAYER_GSTREAMER_H_
+
+#include <string>
+#include <vector>
+
+#include "base/basictypes.h"
+#include "base/compiler_specific.h"
+#include "base/memory/ref_counted.h"
+#include "base/memory/scoped_ptr.h"
+#include "base/memory/weak_ptr.h"
+#include "base/time/default_tick_clock.h"
+#include "base/time/time.h"
+#include "base/threading/thread.h"
+#include "cc/layers/video_frame_provider.h"
+#include "content/common/media/media_channel_host.h"
+#include "content/common/media/media_player_messages_gstreamer.h"
+#include "content/common/media/media_process_launch_causes.h"
+#include "ipc/ipc_listener.h"
+#include "ipc/ipc_message_macros.h"
+#include "media/base/cdm_factory.h"
+#include "media/base/media_export.h"
+#include "media/base/pipeline.h"
+#include "media/base/ranges.h"
+#include "media/base/renderer_factory.h"
+#include "media/base/text_track.h"
+#include "media/base/time_delta_interpolator.h"
+#include "media/blink/buffered_data_source.h"
+#include "media/blink/buffered_data_source_host_impl.h"
+#include "media/blink/encrypted_media_player_support.h"
+#include "media/blink/encrypted_media_player_support.h"
+#include "media/blink/webmediaplayer_util.h"
+#include "third_party/WebKit/public/platform/WebContentDecryptionModuleResult.h"
+#include "third_party/WebKit/public/platform/WebMediaPlayer.h"
+#include "third_party/WebKit/public/platform/WebMediaPlayerClient.h"
+#include "url/gurl.h"
+
+namespace base {
+class SingleThreadTaskRunner;
+}
+
+namespace blink {
+class WebGraphicsContext3D;
+class WebLocalFrame;
+}
+
+namespace cc_blink {
+class WebLayerImpl;
+}
+
+namespace media {
+class MediaLog;
+class WebMediaPlayerDelegate;
+class WebMediaPlayerGStreamer;
+class WebMediaSourceGStreamer;
+
+class WebMediaPlayerMessageDispatcher
+    : public IPC::Listener,
+      public base::SupportsWeakPtr<WebMediaPlayerMessageDispatcher> {
+ public:
+  WebMediaPlayerMessageDispatcher(
+      int player_id,
+      base::WeakPtr<WebMediaPlayerGStreamer> player);
+  ~WebMediaPlayerMessageDispatcher();
+
+  void SendCreate();
+  void SendLoad(GURL);
+  void SendStart();
+  void SendPause();
+  void SendSeek(base::TimeDelta);
+  void SendRelease();
+  void SendRealeaseTexture(unsigned texture_id);
+
+  // MSE
+  bool SendAddSourceId(const std::string& id,
+                       const std::string& type,
+                       const std::vector<std::string>& codecs);
+  void SendRemoveSourceId(const std::string& id);
+  void SendSetDuration(const base::TimeDelta& duration);
+  void SendMarkEndOfStream();
+  void SendUnmarkEndOfStream();
+  void SendSetSequenceMode(const std::string& id, bool sequence_mode);
+  void SendAppendData(const std::string& id,
+                      const unsigned char* data,
+                      unsigned length,
+                      const base::TimeDelta& append_window_start,
+                      const base::TimeDelta& append_window_end,
+                      const base::TimeDelta& timestamp_offset);
+  void SendAbort(const std::string& id);
+  void SendSetGroupStartTimestampIfInSequenceMode(
+      const std::string& id,
+      const base::TimeDelta& timestamp_offset);
+  void SendRemoveSegment(const std::string& id,
+                         const base::TimeDelta& start,
+                         const base::TimeDelta& end);
+  void SendAddKey(const std::string& session_id,
+                  const std::string& key_id,
+                  const std::string& key);
+
+  bool OnMessageReceived(const IPC::Message& message) override;
+
+  scoped_refptr<base::SingleThreadTaskRunner> GetTaskRunner() {
+    return task_runner_.get();
+  }
+
+ private:
+  int player_id_;
+  base::WeakPtr<WebMediaPlayerGStreamer> player_;
+  scoped_refptr<base::SingleThreadTaskRunner> task_runner_;
+};
+
+// TODO: use ubercompositor to avoid inheriting from cc::VideoFrameProvider.
+// Instead MediaPlayerGStreamer form Media Process will inherit this interface.
+class MEDIA_EXPORT WebMediaPlayerGStreamer
+    : public NON_EXPORTED_BASE(blink::WebMediaPlayer),
+      public cc::VideoFrameProvider,
+      public base::SupportsWeakPtr<WebMediaPlayerGStreamer> {
+ public:
+  WebMediaPlayerGStreamer(blink::WebLocalFrame* frame,
+                          blink::WebMediaPlayerClient* client,
+                          base::WeakPtr<WebMediaPlayerDelegate> delegate,
+                          CdmFactory* cdm_factory,
+                          media::MediaPermission* media_permission,
+                          blink::WebContentDecryptionModule* initial_cdm,
+                          MediaLog* media_log);
+  virtual ~WebMediaPlayerGStreamer();
+
+  void SetVideoFrameProviderClient(
+      cc::VideoFrameProvider::Client* client) override;
+  bool UpdateCurrentFrame(base::TimeTicks deadline_min,
+                          base::TimeTicks deadline_max) override;
+  bool HasCurrentFrame() override;
+  scoped_refptr<media::VideoFrame> GetCurrentFrame() override;
+  void PutCurrentFrame() override;
+
+  virtual void load(LoadType load_type,
+                    const blink::WebURL& url,
+                    CORSMode cors_mode);
+
+  // Playback controls.
+  virtual void play();
+  virtual void pause();
+  virtual bool supportsSave() const;
+  virtual void seek(double seconds);
+  virtual void setRate(double rate);
+  virtual void setVolume(double volume);
+  virtual void setSinkId(const blink::WebString& device_id,
+                         WebSetSinkIdCB* web_callbacks);
+  virtual void setPreload(blink::WebMediaPlayer::Preload preload);
+  virtual blink::WebTimeRanges buffered() const;
+  virtual blink::WebTimeRanges seekable() const;
+
+  // Methods for painting.
+  virtual void paint(blink::WebCanvas* canvas,
+                     const blink::WebRect& rect,
+                     unsigned char alpha,
+                     SkXfermode::Mode mode);
+
+  // True if the loaded media has a playable video/audio track.
+  virtual bool hasVideo() const;
+  virtual bool hasAudio() const;
+
+  // Dimensions of the video.
+  virtual blink::WebSize naturalSize() const;
+
+  // Getters of playback state.
+  virtual bool paused() const;
+  virtual bool seeking() const;
+  virtual double duration() const;
+  virtual double timelineOffset() const;
+  virtual double currentTime() const;
+
+  // Internal states of loading and network.
+  virtual blink::WebMediaPlayer::NetworkState networkState() const;
+  virtual blink::WebMediaPlayer::ReadyState readyState() const;
+
+  virtual bool didLoadingProgress();
+
+  virtual bool hasSingleSecurityOrigin() const;
+  virtual bool didPassCORSAccessCheck() const;
+
+  virtual double mediaTimeForTimeValue(double timeValue) const;
+
+  virtual unsigned decodedFrameCount() const;
+  virtual unsigned droppedFrameCount() const;
+  virtual unsigned audioDecodedByteCount() const;
+  virtual unsigned videoDecodedByteCount() const;
+
+  // TODO(dshwang): remove |level|. crbug.com/443151
+  virtual bool copyVideoTextureToPlatformTexture(
+      blink::WebGraphicsContext3D* web_graphics_context,
+      unsigned int texture,
+      unsigned int level,
+      unsigned int internal_format,
+      unsigned int type,
+      bool premultiply_alpha,
+      bool flip_y);
+  virtual bool copyVideoTextureToPlatformTexture(
+      blink::WebGraphicsContext3D* web_graphics_context,
+      unsigned int texture,
+      unsigned int internal_format,
+      unsigned int type,
+      bool premultiply_alpha,
+      bool flip_y);
+
+  virtual MediaKeyException generateKeyRequest(
+      const blink::WebString& key_system,
+      const unsigned char* init_data,
+      unsigned init_data_length);
+
+  virtual MediaKeyException addKey(const blink::WebString& key_system,
+                                   const unsigned char* key,
+                                   unsigned key_length,
+                                   const unsigned char* init_data,
+                                   unsigned init_data_length,
+                                   const blink::WebString& session_id);
+
+  virtual MediaKeyException cancelKeyRequest(
+      const blink::WebString& key_system,
+      const blink::WebString& session_id);
+
+  virtual void setContentDecryptionModule(
+      blink::WebContentDecryptionModule* cdm,
+      blink::WebContentDecryptionModuleResult result);
+
+  void OnAddTextTrack(const TextTrackConfig& config,
+                      const AddTextTrackDoneCB& done_cb);
+
+  void OnReleaseTexture(unsigned texture_id, uint32 release_sync_point);
+
+  void OnSetCurrentFrame(int width,
+                         int height,
+                         unsigned texture_id,
+                         unsigned target,
+                         const std::vector<int32_t>& name);
+  void OnMediaDurationChanged(const base::TimeDelta& duration);
+  void OnMediaPlaybackCompleted();
+  void OnMediaBufferingUpdate(int percent);
+  void OnSeekCompleted(const base::TimeDelta& current_time);
+  void OnMediaError(int error);
+  void OnVideoSizeChanged(int width, int height);
+  void OnTimeUpdate(base::TimeDelta current_timestamp,
+                    base::TimeTicks current_time_ticks);
+  void OnMediaPlayerReleased();
+  void OnPlayerPlay();
+  void OnPlayerPause();
+
+  void OnSourceSelected();
+  void OnSourceDeleted(WebMediaSourceGStreamer*);
+  void OnAddSourceId(const std::string& id);
+  void OnRemoveSourceId(const std::string& id);
+  void OnInitSegmentReceived(const std::string& id);
+  void OnBufferedRangeUpdate(const std::string& id,
+                             const std::vector<base::TimeDelta>& raw_ranges);
+  void OnTimestampOffsetUpdate(const std::string& id,
+                               const base::TimeDelta& timestamp_offset);
+  void OnNeedKey(const std::string& system_id,
+                 const std::vector<uint8>& init_data);
+
+ private:
+  void SetupGLContext();
+  void SetCurrentFrameInternal(scoped_refptr<media::VideoFrame>& frame);
+
+  // Called after |defer_load_cb_| has decided to allow the load. If
+  // |defer_load_cb_| is null this is called immediately.
+  void DoLoad(LoadType load_type, const blink::WebURL& url, CORSMode cors_mode);
+
+  // Helpers that set the network/ready state and notifies the client if
+  // they've changed.
+  void SetNetworkState(blink::WebMediaPlayer::NetworkState state);
+  void SetReadyState(blink::WebMediaPlayer::ReadyState state);
+
+  // Called when the demuxer encounters encrypted streams.
+  void OnEncryptedMediaInitData(EmeInitDataType init_data_type,
+                                const std::vector<uint8>& init_data);
+
+  // Called when a decoder detects that the key needed to decrypt the stream
+  // is not available.
+  void OnWaitingForDecryptionKey();
+
+  void SetCdm(const CdmAttachedCB& cdm_attached_cb, CdmContext* cdm_context);
+
+  // Called when a CDM has been attached to the |pipeline_|.
+  void OnCdmAttached(blink::WebContentDecryptionModuleResult result,
+                     bool success);
+
+  void OnCdmKeysReady(const std::string& session_id,
+                      bool has_additional_usable_key,
+                      CdmKeysInfo keys_info);
+
+  void UpdatePlayingState(bool is_playing);
+
+  // A pointer back to the compositor to inform it about state changes. This is
+  // not NULL while the compositor is actively using this webmediaplayer.
+  // Accessed on main thread and on compositor thread when main thread is
+  // blocked.
+  cc::VideoFrameProvider::Client* video_frame_provider_client_;
+  const scoped_refptr<base::SingleThreadTaskRunner> compositor_loop_;
+  scoped_ptr<cc_blink::WebLayerImpl> video_weblayer_;
+  scoped_refptr<media::VideoFrame> current_frame_;
+  base::Lock current_frame_lock_;
+
+  blink::WebLocalFrame* frame_;
+
+  // TODO(hclam): get rid of these members and read from the pipeline directly.
+  blink::WebMediaPlayer::NetworkState network_state_;
+  blink::WebMediaPlayer::ReadyState ready_state_;
+
+  // Preload state for when |data_source_| is created after setPreload().
+  BufferedDataSource::Preload preload_;
+
+  // Task runner for posting tasks on Chrome's main thread. Also used
+  // for DCHECKs so methods calls won't execute in the wrong thread.
+  const scoped_refptr<base::SingleThreadTaskRunner> main_task_runner_;
+
+  scoped_refptr<base::SingleThreadTaskRunner> media_task_runner_;
+  scoped_refptr<MediaLog> media_log_;
+
+  // The LoadType passed in the |load_type| parameter of the load() call.
+  LoadType load_type_;
+
+  // Cache of metadata for answering hasAudio(), hasVideo(), and naturalSize().
+  PipelineMetadata pipeline_metadata_;
+
+  // Playback state.
+  //
+  // TODO(scherkus): we have these because Pipeline favours the simplicity of a
+  // single "playback rate" over worrying about paused/stopped etc...  It forces
+  // all clients to manage the pause+playback rate externally, but is that
+  // really a bad thing?
+  //
+  // TODO(scherkus): since SetPlaybackRate(0) is asynchronous and we don't want
+  // to hang the render thread during pause(), we record the time at the same
+  // time we pause and then return that value in currentTime().  Otherwise our
+  // clock can creep forward a little bit while the asynchronous
+  // SetPlaybackRate(0) is being executed.
+  bool paused_;
+  bool seeking_;
+  base::TimeDelta seek_time_;
+  double playback_rate_;
+  base::TimeDelta paused_time_;
+  base::TimeDelta duration_;
+
+  // Size of the video.
+  blink::WebSize natural_size_;
+
+  // TODO(scherkus): Replace with an explicit ended signal to HTMLMediaElement,
+  // see http://crbug.com/409280
+  bool ended_;
+
+  // Seek gets pending if another seek is in progress. Only last pending seek
+  // will have effect.
+  bool pending_seek_;
+  base::TimeDelta pending_seek_time_;
+
+  bool did_loading_progress_;
+
+  // Save the list of buffered time ranges.
+  blink::WebTimeRanges buffered_;
+
+  blink::WebMediaPlayerClient* client_;
+
+  // base::TickClock used by |interpolator_|.
+  base::DefaultTickClock default_tick_clock_;
+
+  // Tracks the most recent media time update and provides interpolated values
+  // as playback progresses.
+  media::TimeDeltaInterpolator interpolator_;
+
+  base::WeakPtr<WebMediaPlayerDelegate> delegate_;
+
+  WebMediaSourceGStreamer* media_source_;
+
+  bool supports_save_;
+
+  static base::AtomicSequenceNumber next_player_id_;
+  WebMediaPlayerMessageDispatcher message_dispatcher_;
+
+  EncryptedMediaPlayerSupport encrypted_media_support_;
+
+  DISALLOW_COPY_AND_ASSIGN(WebMediaPlayerGStreamer);
+};
+
+}  // namespace media
+
+#endif  // MEDIA_GSTREAMER_WEBMEDIAPLAYER_GSTREAMER_H_
diff --git a/content/renderer/media/gstreamer/webmediasource_gstreamer.cc b/content/renderer/media/gstreamer/webmediasource_gstreamer.cc
new file mode 100644
index 0000000..5c66d70
--- /dev/null
+++ b/content/renderer/media/gstreamer/webmediasource_gstreamer.cc
@@ -0,0 +1,128 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/renderer/media/gstreamer/webmediasource_gstreamer.h"
+
+#include "base/guid.h"
+#include "content/renderer/media/gstreamer/webmediaplayer_gstreamer.h"
+#include "content/renderer/media/gstreamer/websourcebuffer_gstreamer.h"
+#include "media/blink/websourcebuffer_impl.h"
+#include "media/filters/chunk_demuxer.h"
+#include "third_party/WebKit/public/platform/WebCString.h"
+#include "third_party/WebKit/public/platform/WebString.h"
+
+using ::blink::WebString;
+using ::blink::WebMediaSource;
+
+namespace media {
+
+#define STATIC_ASSERT_MATCHING_STATUS_ENUM(webkit_name, chromium_name) \
+  static_assert(static_cast<int>(WebMediaSource::webkit_name) ==       \
+                    static_cast<int>(ChunkDemuxer::chromium_name),     \
+                "mismatching status enum values: " #webkit_name)
+STATIC_ASSERT_MATCHING_STATUS_ENUM(AddStatusOk, kOk);
+STATIC_ASSERT_MATCHING_STATUS_ENUM(AddStatusNotSupported, kNotSupported);
+STATIC_ASSERT_MATCHING_STATUS_ENUM(AddStatusReachedIdLimit, kReachedIdLimit);
+#undef STATIC_ASSERT_MATCHING_STATUS_ENUM
+
+WebMediaSourceGStreamer::WebMediaSourceGStreamer(
+    WebMediaPlayerGStreamer* player,
+    WebMediaPlayerMessageDispatcher* message_dispatcher,
+    const SetNetworkStateCB& set_network_state_cb)
+    : player_(player),
+      message_dispatcher_(message_dispatcher),
+      set_network_state_cb_(set_network_state_cb) {
+  DCHECK(player_);
+  DCHECK(message_dispatcher_);
+}
+
+WebMediaSourceGStreamer::~WebMediaSourceGStreamer() {
+  player_->OnSourceDeleted(this);
+}
+
+WebMediaSource::AddStatus WebMediaSourceGStreamer::addSourceBuffer(
+    const blink::WebString& type,
+    const blink::WebVector<blink::WebString>& codecs,
+    blink::WebSourceBuffer** source_buffer) {
+  std::string id = base::GenerateGUID();
+  std::vector<std::string> new_codecs(codecs.size());
+  for (size_t i = 0; i < codecs.size(); ++i)
+    new_codecs[i] = codecs[i].utf8().data();
+
+  if (!message_dispatcher_->SendAddSourceId(id, type.utf8().data(), new_codecs))
+    return WebMediaSource::AddStatusNotSupported;
+
+  WebSourceBufferGStreamer* source_buffer_gstreamer =
+      new WebSourceBufferGStreamer(id, message_dispatcher_);
+
+  *source_buffer = source_buffer_gstreamer;
+  source_buffers_[id] = source_buffer_gstreamer;
+
+  return WebMediaSource::AddStatusOk;
+}
+
+double WebMediaSourceGStreamer::duration() {
+  return player_->duration();
+}
+
+void WebMediaSourceGStreamer::setDuration(double new_duration) {
+  DCHECK_GE(new_duration, 0);
+  message_dispatcher_->SendSetDuration(
+      base::TimeDelta::FromSecondsD(new_duration));
+}
+
+void WebMediaSourceGStreamer::markEndOfStream(
+    WebMediaSource::EndOfStreamStatus) {
+  message_dispatcher_->SendMarkEndOfStream();
+}
+
+void WebMediaSourceGStreamer::unmarkEndOfStream() {
+  message_dispatcher_->SendUnmarkEndOfStream();
+}
+
+void WebMediaSourceGStreamer::OnAddSourceId(const std::string& id) {
+  if (id.empty() || source_buffers_.find(id) == source_buffers_.end())
+    set_network_state_cb_.Run(blink::WebMediaPlayer::NetworkStateFormatError);
+}
+
+void WebMediaSourceGStreamer::OnRemoveSourceId(const std::string& id) {
+  WebSourceBufferGStreamerMap::iterator iter = source_buffers_.find(id);
+  if (iter == source_buffers_.end())
+    set_network_state_cb_.Run(blink::WebMediaPlayer::NetworkStateFormatError);
+  else
+    source_buffers_.erase(iter);
+}
+
+void WebMediaSourceGStreamer::OnInitSegmentReceived(const std::string& id) {
+  WebSourceBufferGStreamerMap::iterator iter = source_buffers_.find(id);
+
+  if (iter == source_buffers_.end())
+    set_network_state_cb_.Run(blink::WebMediaPlayer::NetworkStateFormatError);
+  else
+    iter->second->OnInitSegmentReceived();
+}
+
+void WebMediaSourceGStreamer::OnBufferedRangeUpdate(
+    const std::string& id,
+    const Ranges<base::TimeDelta>& ranges) {
+  WebSourceBufferGStreamerMap::iterator iter = source_buffers_.find(id);
+
+  if (iter == source_buffers_.end())
+    set_network_state_cb_.Run(blink::WebMediaPlayer::NetworkStateFormatError);
+  else
+    iter->second->OnBufferedRangeUpdate(ranges);
+}
+
+void WebMediaSourceGStreamer::OnTimestampOffsetUpdate(
+    const std::string& id,
+    const base::TimeDelta& timestamp_offset) {
+  WebSourceBufferGStreamerMap::iterator iter = source_buffers_.find(id);
+
+  if (iter == source_buffers_.end())
+    set_network_state_cb_.Run(blink::WebMediaPlayer::NetworkStateFormatError);
+  else
+    iter->second->OnTimestampOffsetUpdate(timestamp_offset);
+}
+
+}  // namespace media
diff --git a/content/renderer/media/gstreamer/webmediasource_gstreamer.h b/content/renderer/media/gstreamer/webmediasource_gstreamer.h
new file mode 100644
index 0000000..754dcf6
--- /dev/null
+++ b/content/renderer/media/gstreamer/webmediasource_gstreamer.h
@@ -0,0 +1,68 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_RENDERER_MEDIA_GSTREAMER_WEBMEDIASOURCE_GSTREAMER_H_
+#define CONTENT_RENDERER_MEDIA_GSTREAMER_WEBMEDIASOURCE_GSTREAMER_H_
+
+#include <string>
+#include <vector>
+
+#include "media/base/media_export.h"
+#include "media/base/media_log.h"
+#include "media/base/ranges.h"
+#include "third_party/WebKit/public/platform/WebMediaPlayer.h"
+#include "third_party/WebKit/public/platform/WebMediaSource.h"
+
+namespace media {
+class WebMediaPlayerGStreamer;
+class WebMediaPlayerMessageDispatcher;
+class WebSourceBufferGStreamer;
+
+class WebMediaSourceGStreamer : public blink::WebMediaSource {
+ public:
+  typedef base::Callback<void(blink::WebMediaPlayer::NetworkState)>
+      SetNetworkStateCB;
+
+  WebMediaSourceGStreamer(WebMediaPlayerGStreamer* player,
+                          WebMediaPlayerMessageDispatcher* message_dispatcher,
+                          const SetNetworkStateCB& set_network_state_cb);
+  virtual ~WebMediaSourceGStreamer();
+
+  // blink::WebMediaSource implementation.
+  virtual AddStatus addSourceBuffer(
+      const blink::WebString& type,
+      const blink::WebVector<blink::WebString>& codecs,
+      blink::WebSourceBuffer** source_buffer);
+  virtual double duration();
+  virtual void setDuration(double duration);
+  virtual void markEndOfStream(EndOfStreamStatus status);
+  virtual void unmarkEndOfStream();
+
+  void OnAddSourceId(const std::string& id);
+  void OnRemoveSourceId(const std::string& id);
+  void OnInitSegmentReceived(const std::string& id);
+  void OnBufferedRangeUpdate(const std::string& id,
+                             const Ranges<base::TimeDelta>& ranges);
+  void OnTimestampOffsetUpdate(const std::string& id,
+                               const base::TimeDelta& timestamp_offset);
+
+ private:
+  // WebMediaPlayerGStreamer will not be released before
+  // WebMediaSourceGStreamer.
+  WebMediaPlayerGStreamer* player_;
+  WebMediaPlayerMessageDispatcher* message_dispatcher_;
+  SetNetworkStateCB set_network_state_cb_;
+
+  typedef base::hash_map<std::string, media::WebSourceBufferGStreamer*>
+      WebSourceBufferGStreamerMap;
+  // Threading notes: |dispatchers_| is only accessed on the IO thread. Every
+  // other field is protected by |lock_|.
+  WebSourceBufferGStreamerMap source_buffers_;
+
+  DISALLOW_COPY_AND_ASSIGN(WebMediaSourceGStreamer);
+};
+
+}  // namespace media
+
+#endif  // CONTENT_RENDERER_MEDIA_GSTREAMER_WEBMEDIASOURCE_GSTREAMER_H_
diff --git a/content/renderer/media/gstreamer/websourcebuffer_gstreamer.cc b/content/renderer/media/gstreamer/websourcebuffer_gstreamer.cc
new file mode 100644
index 0000000..5467cdc
--- /dev/null
+++ b/content/renderer/media/gstreamer/websourcebuffer_gstreamer.cc
@@ -0,0 +1,164 @@
+// Copyright 2013 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#include "content/renderer/media/gstreamer/websourcebuffer_gstreamer.h"
+
+#include <cmath>
+#include <limits>
+
+#include "base/bind.h"
+#include "base/callback.h"
+#include "base/callback_helpers.h"
+#include "content/renderer/media/gstreamer/webmediaplayer_gstreamer.h"
+#include "third_party/WebKit/public/platform/WebSourceBufferClient.h"
+
+namespace media {
+
+static base::TimeDelta DoubleToTimeDelta(double time) {
+  DCHECK(!std::isnan(time));
+  DCHECK_NE(time, -std::numeric_limits<double>::infinity());
+
+  if (time == std::numeric_limits<double>::infinity())
+    return kInfiniteDuration();
+
+  // Don't use base::TimeDelta::Max() here, as we want the largest finite time
+  // delta.
+  base::TimeDelta max_time = base::TimeDelta::FromInternalValue(kint64max - 1);
+  double max_time_in_seconds = max_time.InSecondsF();
+
+  if (time >= max_time_in_seconds)
+    return max_time;
+
+  return base::TimeDelta::FromMicroseconds(time *
+                                           base::Time::kMicrosecondsPerSecond);
+}
+
+WebSourceBufferGStreamer::WebSourceBufferGStreamer(
+    const std::string& id,
+    WebMediaPlayerMessageDispatcher* message_dispatcher)
+    : id_(id),
+      message_dispatcher_(message_dispatcher),
+      client_(NULL),
+      initialization_segment_received(false),
+      append_window_end_(kInfiniteDuration()) {
+  DCHECK(message_dispatcher);
+}
+
+WebSourceBufferGStreamer::~WebSourceBufferGStreamer() {
+  DCHECK(!message_dispatcher_)
+      << "Object destroyed w/o removedFromMediaSource() call";
+  DCHECK(!client_);
+}
+
+void WebSourceBufferGStreamer::setClient(blink::WebSourceBufferClient* client) {
+  DCHECK(client);
+  DCHECK(!client_);
+  client_ = client;
+}
+
+bool WebSourceBufferGStreamer::setMode(WebSourceBuffer::AppendMode mode) {
+  switch (mode) {
+    case WebSourceBuffer::AppendModeSegments:
+      message_dispatcher_->SendSetSequenceMode(id_, false);
+      return true;
+    case WebSourceBuffer::AppendModeSequence:
+      message_dispatcher_->SendSetSequenceMode(id_, true);
+      return true;
+  }
+
+  NOTREACHED();
+  return false;
+}
+
+blink::WebTimeRanges WebSourceBufferGStreamer::buffered() {
+  blink::WebTimeRanges result(ranges_.size());
+  for (size_t i = 0; i < ranges_.size(); i++) {
+    result[i].start = ranges_.start(i).InSecondsF();
+    result[i].end = ranges_.end(i).InSecondsF();
+  }
+
+  return result;
+}
+
+void WebSourceBufferGStreamer::append(const unsigned char* data,
+                                      unsigned length,
+                                      double* timestamp_offset) {
+  if (initialization_segment_received) {
+    initialization_segment_received = false;
+    client_->initializationSegmentReceived();
+  }
+
+  base::TimeDelta old_offset = timestamp_offset_;
+
+  message_dispatcher_->SendAppendData(id_, data, length, append_window_start_,
+                                      append_window_end_, timestamp_offset_);
+
+  // Coded frame processing may update the timestamp offset. If the caller
+  // provides a non-NULL |timestamp_offset| and frame processing changes the
+  // timestamp offset, report the new offset to the caller. Do not update the
+  // caller's offset otherwise, to preserve any pre-existing value that may have
+  // more than microsecond precision.
+  if (timestamp_offset && old_offset != timestamp_offset_)
+    *timestamp_offset = timestamp_offset_.InSecondsF();
+}
+
+void WebSourceBufferGStreamer::abort() {
+  message_dispatcher_->SendAbort(id_);
+}
+
+void WebSourceBufferGStreamer::remove(double start, double end) {
+  DCHECK_GE(start, 0);
+  DCHECK_GE(end, 0);
+  message_dispatcher_->SendRemoveSegment(id_, DoubleToTimeDelta(start),
+                                         DoubleToTimeDelta(end));
+}
+
+bool WebSourceBufferGStreamer::setTimestampOffset(double offset) {
+  timestamp_offset_ = DoubleToTimeDelta(offset);
+
+  // http://www.w3.org/TR/media-source/#widl-SourceBuffer-timestampOffset
+  // Step 6: If the mode attribute equals "sequence", then set the group start
+  // timestamp to new timestamp offset.
+  message_dispatcher_->SendSetGroupStartTimestampIfInSequenceMode(
+      id_, timestamp_offset_);
+  return true;
+}
+
+void WebSourceBufferGStreamer::setAppendWindowStart(double start) {
+  DCHECK_GE(start, 0);
+  append_window_start_ = DoubleToTimeDelta(start);
+}
+
+void WebSourceBufferGStreamer::setAppendWindowEnd(double end) {
+  DCHECK_GE(end, 0);
+  append_window_end_ = DoubleToTimeDelta(end);
+}
+
+void WebSourceBufferGStreamer::removedFromMediaSource() {
+  message_dispatcher_->SendRemoveSourceId(id_);
+  message_dispatcher_ = NULL;
+  client_ = NULL;
+}
+
+void WebSourceBufferGStreamer::OnInitSegmentReceived() {
+  DVLOG(1) << __FUNCTION__;
+  // Cannot notify the client here because SourceBuffer
+  // might be updating. Indeed there is ASSERT(m_updating)
+  // in SourceBuffer::initializationSegmentReceived().
+  initialization_segment_received = true;
+}
+
+void WebSourceBufferGStreamer::OnBufferedRangeUpdate(
+    const Ranges<base::TimeDelta>& ranges) {
+  DVLOG(1) << __FUNCTION__;
+  ranges_ = ranges;
+}
+
+void WebSourceBufferGStreamer::OnTimestampOffsetUpdate(
+    const base::TimeDelta& timestamp_offset) {
+  DVLOG(1) << __FUNCTION__;
+  timestamp_offset_ = timestamp_offset;
+}
+
+}  // namespace media
diff --git a/content/renderer/media/gstreamer/websourcebuffer_gstreamer.h b/content/renderer/media/gstreamer/websourcebuffer_gstreamer.h
new file mode 100644
index 0000000..d13a85d
--- /dev/null
+++ b/content/renderer/media/gstreamer/websourcebuffer_gstreamer.h
@@ -0,0 +1,67 @@
+// Copyright 2015 The Chromium Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be
+// found in the LICENSE file.
+
+#ifndef CONTENT_RENDERER_MEDIA_GSTREAMER_WEBSOURCEBUFFER_GSTREAMER_H_
+#define CONTENT_RENDERER_MEDIA_GSTREAMER_WEBSOURCEBUFFER_GSTREAMER_H_
+
+#include <string>
+
+#include "base/basictypes.h"
+#include "base/compiler_specific.h"
+#include "base/time/time.h"
+#include "media/base/ranges.h"
+#include "third_party/WebKit/public/platform/WebSourceBuffer.h"
+
+namespace media {
+class WebMediaPlayerMessageDispatcher;
+
+class WebSourceBufferGStreamer : public blink::WebSourceBuffer {
+ public:
+  WebSourceBufferGStreamer(const std::string& id,
+                           WebMediaPlayerMessageDispatcher* message_dispatcher);
+  virtual ~WebSourceBufferGStreamer();
+
+  // blink::WebSourceBuffer implementation.
+  virtual void setClient(blink::WebSourceBufferClient* client);
+  virtual bool setMode(AppendMode mode);
+  virtual blink::WebTimeRanges buffered();
+  virtual void append(const unsigned char* data,
+                      unsigned length,
+                      double* timestamp_offset);
+  virtual void abort();
+  virtual void remove(double start, double end);
+  virtual bool setTimestampOffset(double offset);
+  virtual void setAppendWindowStart(double start);
+  virtual void setAppendWindowEnd(double end);
+  virtual void removedFromMediaSource();
+
+  void OnInitSegmentReceived();
+  void OnBufferedRangeUpdate(const Ranges<base::TimeDelta>& ranges);
+  void OnTimestampOffsetUpdate(const base::TimeDelta& timestamp_offset);
+
+ private:
+  std::string id_;
+  WebMediaPlayerMessageDispatcher*
+      message_dispatcher_;  // Owned by WebMediaPlayerGStreamer.
+
+  blink::WebSourceBufferClient* client_;
+
+  bool initialization_segment_received;
+
+  // Controls the offset applied to timestamps when processing appended media
+  // segments. It is initially 0, which indicates that no offset is being
+  // applied. Both setTimestampOffset() and append() may update this value.
+  base::TimeDelta timestamp_offset_;
+
+  base::TimeDelta append_window_start_;
+  base::TimeDelta append_window_end_;
+
+  Ranges<base::TimeDelta> ranges_;
+
+  DISALLOW_COPY_AND_ASSIGN(WebSourceBufferGStreamer);
+};
+
+}  // namespace media
+
+#endif  // CONTENT_RENDERER_MEDIA_GSTREAMER_WEBSOURCEBUFFER_GSTREAMER_H_
